#!/bin/bash

ACCOUNT_STATUS_PATH="/usr/share/nfs-security/core/SystemSafe/tmp/account_status.list"
PASSWD_PATH="/etc/passwd"
SHADOW_PATH="/etc/shadow"

# 判断/etc/passwd是否存在
if [ ! -f "$PASSWD_PATH" ]; then
	echo "no $PASSWD_PATH in system."
	exit 1
fi

# 判断/etc/shadow是否存在
if [ ! -f "$SHADOW_PATH" ]; then
	echo "no $SHADOW_PATH in system."
	exit 1
fi

# 判断异常列表文件及目录是否存在
if [ ! -d "$(dirname $ACCOUNT_STATUS_PATH)" ]; then
	mkdir -p $(dirname $ACCOUNT_STATUS_PATH)
fi

# 初始化异常列表
> $ACCOUNT_STATUS_PATH

# 判断是否含有uid为0的非root帐号
cut -d ":" -f 1,3 $PASSWD_PATH | grep ":0$" | grep -v "^root:" | awk -F: '{print $1":UIDError"}' >> $ACCOUNT_STATUS_PATH

# 判断是否是空口令帐号
cut -d ":" -f 1,2 $SHADOW_PATH | awk -F: '{if($2 == "")print $1":Empty"}' >> $ACCOUNT_STATUS_PATH

# 判断帐号是否被锁定
for i in $(cut -d ":" -f 1,3 $PASSWD_PATH)
do
	uid=$(echo $i | cut -d ":" -f 2)
	if [ "$uid" -lt 1000 ] || [ "$uid" -gt 60000 ]; then
		continue;
	fi
	account=$(echo $i | cut -d ":" -f 1)
	passwd -S $account | awk '{if($2 == "L"){print $1":Lock"}}' >> $ACCOUNT_STATUS_PATH
done
